## ros-melodic-rosfmt 6.2.0

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.0)
project(rosfmt)

find_package(catkin REQUIRED COMPONENTS
	roscpp
	rosconsole
)

# Get fmt from an official release
include(ExternalProject)
ExternalProject_Add(
	fmt
	URL https://github.com/fmtlib/fmt/releases/download/6.0.0/fmt-6.0.0.zip
	URL_HASH SHA256=b4a16b38fa171f15dbfb958b02da9bbef2c482debadf64ac81ec61b5ac422440
	CONFIGURE_COMMAND ""

	# We touch all downloaded files, otherwise they get some timestamp in the
	# past and may confuse the dependency tracking below.
	BUILD_COMMAND find <SOURCE_DIR> -type f -exec touch {} +
	INSTALL_COMMAND ""
)

# Now extract the needed files. We need to copy headers to the devel space
# b/c of catkin policies (they count as "generated headers").
ExternalProject_Get_property(fmt SOURCE_DIR)
set(fmt_SOURCE_DIR "${SOURCE_DIR}")
set(fmt_HEADER_DEST "${CATKIN_DEVEL_PREFIX}/${CATKIN_GLOBAL_INCLUDE_DESTINATION}")

file(MAKE_DIRECTORY ${fmt_HEADER_DEST})
foreach(FILE chrono.h color.h compile.h core.h format-inl.h format.h locale.h ostream.h posix.h printf.h ranges.h safe-duration-cast.h)
	set(in "${fmt_SOURCE_DIR}/include/fmt/${FILE}")
	set(out "${fmt_HEADER_DEST}/fmt/${FILE}")
	list(APPEND fmt_HEADERS_OUT ${out})

	set_source_files_properties(${in} PROPERTIES GENERATED TRUE)
	set_source_files_properties(${out} PROPERTIES GENERATED TRUE)

	add_custom_command(
		OUTPUT ${out}
		DEPENDS ${in} fmt
		COMMAND cmake -E copy_if_different "${in}" "${out}"
	)
endforeach()

add_custom_target(fmt_headers
	DEPENDS ${fmt_HEADERS_OUT}
)

catkin_package(
	INCLUDE_DIRS include ${fmt_HEADER_DEST}
	CATKIN_DEPENDS roscpp rosconsole
	LIBRARIES rosfmt
)

include_directories(
	${fmt_HEADER_DEST}
	${catkin_INCLUDE_DIRS}
	include
)

set(CMAKE_CXX_STANDARD 11)

set_source_files_properties(
	${fmt_SOURCE_DIR}/src/format.cc
	${fmt_SOURCE_DIR}/src/posix.cc
	PROPERTIES GENERATED TRUE
)

add_library(rosfmt
	${fmt_HEADERS_OUT}
	${fmt_SOURCE_DIR}/src/format.cc
	${fmt_SOURCE_DIR}/src/posix.cc
	src/rosfmt.cpp
)
target_link_libraries(rosfmt
	${catkin_LIBRARIES}
)
add_dependencies(rosfmt fmt fmt_headers)

add_executable(simple_test
	test/test.cpp
)
target_link_libraries(simple_test rosfmt)

install(
	DIRECTORY ${fmt_HEADER_DEST}/fmt/
	DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/fmt
)
install(
	DIRECTORY include/rosfmt/
	DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)
install(
	TARGETS rosfmt
	DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

=== debian/changelog ===
ros-melodic-rosfmt (6.2.0-1stretch) stretch; urgency=high

  * ensure vformat is only instantiated once -> faster compile times
  * update to fmt 6.0.0
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@ais.uni-bonn.de>  Wed, 08 Jan 2020 23:00:00 -0000

ros-melodic-rosfmt (6.1.0-1stretch) stretch; urgency=high

  * cmake: fix dependency tracking bugs
  * update fmt to version 5.3.0
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@ais.uni-bonn.de>  Mon, 13 May 2019 22:00:00 -0000

ros-melodic-rosfmt (6.0.0-1stretch) stretch; urgency=high

  * Major release bump to decouple rosfmt and fmt versions
  * rosfmt.h: produce nicer error message if C++11 is not available
  * cmake: add transitive rosconsole / roscpp deps
  * README: add CMake example
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@ais.uni-bonn.de>  Tue, 13 Nov 2018 23:00:00 -0000

ros-melodic-rosfmt (5.2.2-1stretch) stretch; urgency=high

  * README: syntax highlighting
  * add README.md, LICENSE.txt
  * initial commit - basics are working
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@ais.uni-bonn.de>  Sun, 28 Oct 2018 23:00:00 -0000

=== debian/control ===
Source: ros-melodic-rosfmt
Section: misc
Priority: optional
Maintainer: Max Schwarz <max.schwarz@ais.uni-bonn.de>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-rosconsole, ros-melodic-roscpp
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-rosfmt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-rosconsole, ros-melodic-roscpp
Description: fmt is an open-source formatting library for C++.
 It can be used as a safe and fast alternative to (s)printf and IOStreams.

## ros-melodic-rosfmt 7.0.0

=== debian/changelog ===
ros-melodic-rosfmt (7.0.0-1bionic) bionic; urgency=high

  * rename rosfmt library to rosfmt7 to prevent ABI mismatches
  * Update fmt to 7.1.2
  * cmake: fix ordering of internal include paths
  * add new full.h header (issue: #2)
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@ais.uni-bonn.de>  Sun, 03 Jan 2021 05:00:00 -0000

ros-melodic-rosfmt (6.2.0-1bionic) bionic; urgency=high

  * ensure vformat is only instantiated once -> faster compile times
  * update to fmt 6.0.0
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@ais.uni-bonn.de>  Thu, 09 Jan 2020 05:00:00 -0000

ros-melodic-rosfmt (6.1.0-1bionic) bionic; urgency=high

  * cmake: fix dependency tracking bugs
  * update fmt to version 5.3.0
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@ais.uni-bonn.de>  Tue, 14 May 2019 04:00:00 -0000

ros-melodic-rosfmt (6.0.0-1bionic) bionic; urgency=high

  * Major release bump to decouple rosfmt and fmt versions
  * rosfmt.h: produce nicer error message if C++11 is not available
  * cmake: add transitive rosconsole / roscpp deps
  * README: add CMake example
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@ais.uni-bonn.de>  Wed, 14 Nov 2018 05:00:00 -0000

ros-melodic-rosfmt (5.2.2-1bionic) bionic; urgency=high

  * README: syntax highlighting
  * add README.md, LICENSE.txt
  * initial commit - basics are working
  * Contributors: Max Schwarz

 -- Max Schwarz <max.schwarz@ais.uni-bonn.de>  Mon, 29 Oct 2018 04:00:00 -0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-rosfmt//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
